#define NODO_VERSION_MINOR              10
#define NODO_VERSION_MAJOR               3
#define EVENT_BOOT                       1
#define EVENT_USEREVENT                  3
#define VALUE_ALL                       18
#define CMD_CLOCK_TIME                  34
#define VALUE_DIRECTION_OUTPUT          77

#define NODO_TYPE_EVENT                  1
#define NODO_TYPE_COMMAND                2
#define NODO_TYPE_SYSTEM                 3               
#define NODO_TYPE_PLUGIN_EVENT           4
#define NODO_TYPE_PLUGIN_COMMAND         5

struct SettingsStruct
  {
  byte    Unit; // Max 5 bits in gebruik = 1..31
  }Settings;


struct NodoEventStruct
  {
  // Event deel
  byte Type;
  byte Command;
  byte Par1;
  unsigned long Par2;

  // Transmissie deel
  byte SourceUnit;
  byte DestinationUnit;
  byte Flags;
  byte Port;
  byte Direction;
  byte Version;
  byte Checksum;
  };
  
boolean Checksum(struct NodoEventStruct *event)
  {
  byte OldChecksum=event->Checksum;
  byte NewChecksum=NODO_VERSION_MAJOR;  // Verwerk versie in checksum om communicatie tussen verschillende versies te voorkomen

  event->Checksum=0; // anders levert de beginsituatie een andere checksum op

  for(int x=0;x<sizeof(struct NodoEventStruct);x++)
    NewChecksum^(*((byte*)event+x)); 

  event->Checksum=NewChecksum;
  return(OldChecksum==NewChecksum);
  }
  
  char* ProgmemString(prog_char* text)
{
 byte x=0;
 static char buffer[20];

 do
 {
   buffer[x]=pgm_read_byte_near(text+x);
 }
 while(buffer[x++]!=0);
 return buffer;
}
void ClearEvent(struct NodoEventStruct *Event)
{    
  Event->Command            = 0;
  Event->Par1               = 0;
  Event->Par2               = 0L;
  Event->Flags              = 0;
  Event->Port               = 0;
  Event->Type               = 0;
  Event->Direction          = 0;
  Event->DestinationUnit    = 0;
  Event->SourceUnit         = Settings.Unit;
  Event->Version            = NODO_VERSION_MINOR;
  Event->Checksum           = 0;
}
